/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2004/10/17 FreeNote 1.10.0[X
2004/08/26 ver 1.9.3pre
Er@\ǉ

2004/05/23 ver 1.9.1Apre
EΉ

2004/02/16 ver 1.7.3pre
EҏW@\

2004/02/14 ver 1.7.2pre
E@\ǉ

2004/02/12 ver 1.7.1pre
EtHgdl̕ύX
EeLXg̍
EeLXg{bNX̑@\

2003/02/10 ver 1.7.0pre
E

2003/12/23 ver 1.6.1
Eۑ̃TCYk

2003/12/16-19 ver 1.5.5pre
EyTCY̒ǉ(1-8)
EAhDEhD̎

2003/12/14 ver 1.5.4pre
EyTCYI\ɁB

2003/12/05 ver 1.5.3Apre
EObh̐FC

2003/12/04 ver 1.5.3pre
EObh̕`ꕔC

2003/11/10 ver 1.5.1pre
EȐ`[hǉ

2003/11/09 ver 1.5.0pre
E`[hǉ

2003/09/03 ver 1.3.4pre
EUse all quadrant OFFɕ\ʒuZbgꍇoOΉB

2003/09/01-03 ver 1.3.3pre
EXN[̉
EUse all quadrant(Sیgp)j[ǉ

2003/08/31 FreeNote 1.3.2pre
ESXN[

2003/08/23 FreeNote 1.3.0pre
ECȐC

2003/08/15 FreeNote 1.2.1J
Eۑ̃oOC
E_CAO̎
EPNGt@Cւ̏o

2003/08/15 FreeNote 1.2J
EIvVǉ
EXN[KCh
EFreet@C֘At
EACR̕ύX

2003/08/05 FreeNote 1.1.1preJ
ENɕԂێ
E`惂[hؑւɏS\
EۑԒZk
EView[h̋ύX
Ej[̌ڂύX
*/
#include "fncanvas.h"
#include <qsjiscodec.h> 
#include <stdio.h>
#include <qfile.h>
#include <qmessagebox.h>
#include <qtextstream.h>
#include <qpen.h>
#include <qcolor.h>
#include <qpoint.h>
#include <qthread.h>
#include <qimage.h>
#include <math.h>
#include <qtextcodec.h>
#include <qmultilineedit.h>
#include <qbitmap.h>
#include "fnmessagebox.h"
#include "fmtengine.h"
#include "fntextdialog.h"
#include <qfont.h>

int snap(int v) {
	int tv = abs(v);
	tv = ((int)(tv + SNAP_SIZE / 2) / SNAP_SIZE) * SNAP_SIZE;
	if (0 > v) {
		return -tv;
	} else {
		return tv;
	}
}

FNCanvas::FNCanvas(QWidget* parent = 0, const char* name = 0, WFlags f = 0)
	:QWidget(parent, name, f),
	_txtTmp(NULL),
	_pen(black, 1, SolidLine, RoundCap, RoundJoin), 
	_asMode(AS_NONE),
	_drawMode(MODE_DRAW),
	_disp_offset(0),
	_eraser_l(50),
	_eraser_s(10),
	_h_step(100),
	_v_step(100),
	_margin(5),
	_scrollTiming(800),
	_viewMode(false),
	_isWaiting(false),
	_isDragging(false),
	_isDrawing(false),
	_isHeadingEnables(false),
	_isShowGuide(false),
	_isUseAllQuadrant(false),
	_showRuler(false),
	_scale_x(1.0),
	_scale_y(1.0)
{
	_tracks.setAutoDelete(true);
	_clipboard.setAutoDelete(true);
	this->setBackgroundMode(NoBackground);
	_timer = new QTimer(this);
	connect(_timer, SIGNAL(timeout()), this, SLOT(autoScroll()));
	_dlgFind = new FNFindDialog(this, "Find");
	connect(_dlgFind, SIGNAL(originChanged(int, int)), this, SLOT(setOrigin(int, int)));
	connect(_dlgFind, SIGNAL(resetOrigin()), this, SLOT(resetOrigin()));
}

FNCanvas::~FNCanvas()
{
	_timer->stop();
	delete _timer;

	_tracks.clear();
	clearList(_draws);
	
	delete _dlgFind;
}

void FNCanvas::setScrollTiming(int v)
{
	_scrollTiming = v;
}


void FNCanvas::setVStep(int v)
{
	_v_step = v;
}

void FNCanvas::setHStep(int v)
{
	_h_step = v;
}

void FNCanvas::setSEraser(int v)
{
	_eraser_s = v;
}

void FNCanvas::setLEraser(int v)
{
	_eraser_l = v;
}


void FNCanvas::setMargin(int v)
{
	if (v < 3) {
		v = 3;
	}
	_margin = v;
}
void FNCanvas::find()
{
	if (_viewMode) {
		return;
	}
	_dlgFind->setElements(_draws);
	_dlgFind->show();
	_dlgFind->exec();
}

void FNCanvas::setScrollMode(int as)
{
	_asMode = as;
	redraw();
}

void FNCanvas::autoScroll()
{
	if (AS_NONE == _asMode) {
		//if (MODE_FORMAT == _drawMode || MODE_CURVE == _drawMode || MODE_SMOOTH == _drawMode || MODE_TEXT == _drawMode) {
			setOrigin(_origin.x(), _origin.y());
		//}
		return;
	}
	bool tmp = _isHeadingEnables;
	int dx = 0;
	int dy = 0;
	if (AS_BOTH == _asMode || AS_HORIZONTAL == _asMode) {
		if (_last.x() > width() * (_margin - 1) / _margin) {
			dx = _h_step;
		} else if (_last.x() < width() / _margin) {
			dx = -_h_step;
		}
	}
	if (AS_BOTH == _asMode || AS_VERTICAL == _asMode) {
		if (_last.y() > height() * (_margin - 1) / _margin) {
			dy = _v_step;
		} else if (_last.y() < height() / _margin) {
			dy = -_v_step;
		}
	}
	setOrigin(_origin.x() + dx, _origin.y() + dy);
	_isHeadingEnables = tmp;
}

void FNCanvas::drawRect(QPainter& pa, const QRect& r)
{
	int w = width();
	int h = height();
	int sx = r.left();
	int sy = r.top();
	int ex = r.right();
	int ey = r.bottom();
	if (0 > sx) {
		sx = 0;
	}
	if (0 > sy) {
		sy = 0;
	}
	if (h < ey) {
		ey = h;
	}
	if (w < ex) {
		ex = w;
	}
	if (0 <= r.left()) {
		pa.drawLine(sx, sy, sx, ey);
	}
	if (0 <= r.top()) {
		pa.drawLine(sx, sy, ex, sy);
	}
	if (w >= r.right()) {
		pa.drawLine(ex, sy, ex, ey);
	}
	if (h >= r.bottom()) {
		pa.drawLine(sx, ey, ex, ey);
	}
}

void FNCanvas::mousePressEvent(QMouseEvent* evt)
{
	setFocus();
	_timer->stop();
	_tracks.clear();
	if (_viewMode) {
		_isWaiting = true;
		_viewMode = false;
		setOrigin((int)((evt->x()) / _scale_x) - width() / 2, (int)((evt->y()) / _scale_y) - height() / 2);
		redraw();
		emit resetViewMode();
	} else if (MODE_TEXT == _drawMode) {
		_txtTmp = NULL;
		_last = evt->pos();
		int x = _last.x();
		int y = _last.y();
		for (int i = _draws.count() - _disp_offset - 1; i >= 0; --i) {
			FNPolygon* p = _draws.at((uint)i);
			if (FN_TEXT == p->type()) {
				QRect r = p->boundingRect();
				if (r.contains(x, y)) {
					_txtTmp = (FNText*)p;
					_selection.setRect(0, 0, -1, -1);
					break;
				}
			}
		}
		_last = SnapPoint(evt->pos(), SNAP_SIZE / 4);
	} else if (MODE_ERASE == _drawMode) {
		_last = evt->pos();
		
		if (0 >= _selection.width() || !_selection.contains(_last)) {
			_isSelected = false;
		}
		if (!_isSelected) {
			_selection = QRect(0, 0, -1, -1);
			_selected.clear();
			redraw();

			int w = _eraser_s;
			if (PENWIDTH_MAX / 2 < _pen.width()) {
				w = _eraser_l;
			}
			//if (0 <= _last.x() - w / 2) {
				// oO΍F
				// 0 > x̍WɁAc150ʂ̎lp`ƁACnUẼptH[}X܂B
				// ȍ~l̃WbN͂̑΍̂߂łB
				QPainter pwin;
				pwin.begin(this);
				pwin.setRasterOp(XorROP);
				pwin.setPen(QPen(white, 1));
				_preRect.setRect(_last.x() - w / 2, _last.y() - w / 2, w, w);
				//pwin.drawRect(_preRect);
				drawRect(pwin, _preRect);
				pwin.flush();
				pwin.end();
			//}
			_selection = QRect(0, 0, -1, -1);
			_selected.clear();
		} else {
			//if (0 <= _selection.x()) {
				QPainter pwin;
				pwin.begin(this);

				pwin.setRasterOp(XorROP);
				pwin.setPen(QPen(white, 1));
				_preRect.setRect(_selection.x(), _selection.y(), _selection.width(), _selection.height());
				//pwin.drawRect(_preRect);
				drawRect(pwin, _preRect);

				pwin.flush();
				pwin.end();
			//}
			/*
			_tdx = _last.x() - _selection.x();
			_tdy = _last.y() - _selection.y();
			*/
			QPoint t = SnapPoint(QPoint(_selection.x(), _selection.y()));
			_last = SnapPoint(_last);
			
			_tdx = _last.x() - t.x();
			_tdy = _last.y() - t.y();
		}
	} else {
		_last = evt->pos();
		_tracks.append(new QPoint(_last));
	}
	_isDragging = true;
}

void FNCanvas::mouseMoveEvent(QMouseEvent* evt)
{
	if (_isWaiting) {
		return;
	}
	if (MODE_TEXT == _drawMode) {
		if (NULL == _txtTmp) {
			return;
		}
		QPainter pwin;
		pwin.begin(this);
		if (-1 != _selection.width()) {
			//if (0 <= _selection.x()) {
				pwin.setRasterOp(XorROP);
				pwin.setPen(QPen(white, 1));
				//pwin.drawRect(_selection.x(), _selection.y(), _selection.width(), _selection.height());
				drawRect(pwin, _selection);
			//}
		} else {
			_selection = _txtTmp->boundingRect();
		}
		QPoint tmp = SnapPoint(evt->pos(), SNAP_SIZE / 4);
		if (tmp != _last) {
			_selection.moveTopLeft(tmp);
			_last = tmp;
		}
		//if (0 <= _selection.x()) {
			//pwin.drawRect(_selection.x(), _selection.y(), _selection.width(), _selection.height());
			drawRect(pwin, _selection);
		//}
		pwin.flush();
		pwin.end();
	} else if (MODE_ERASE == _drawMode) {
		//redraw();
		if (_last.x() == -1) {
			return;
		}
		if (!_isSelected) {
			int w = _eraser_s;
			if (PENWIDTH_MAX / 2 < _pen.width()) {
				w = _eraser_l;
			}
			QPainter pwin;
			pwin.begin(this);

			//if (0 <= _preRect.x()) {
				pwin.setRasterOp(XorROP);
				pwin.setPen(QPen(white, 1));
				//pwin.drawRect(_preRect);
				drawRect(pwin, _preRect);
			//}

			//_tracks.append(new QPoint(evt->pos()));
			_last = evt->pos();

			_preRect.setRect(_last.x() - w / 2, _last.y() - w / 2, w, w);
			pwin.setRasterOp(CopyROP);
			QRect r = QRect(0, 0, width(), height());
			for (uint i = 0; i < _draws.count() - _disp_offset; ++i) {
				FNPolygon* p = _draws.at(i);
				QRect bounds = p->boundingRect();
				if (r.intersects(bounds)) {
					bool f = false;
					QRect& selected = _preRect;
					for (uint j = 0; j < p->points().count(); ++j) {
						QPoint& pts = p->points().at(j);
						if (selected.contains(pts)) {
							f = true;
							if (-1 == _selection.width()) {
								_selection = bounds;
							} else {
								if (bounds.x() < _selection.x()) {
									_selection.setX(bounds.x());
								}
								if (bounds.y() < _selection.y()) {
									_selection.setY(bounds.y());
								}
								if (bounds.right() > _selection.right()) {
									_selection.setRight(bounds.right());
								}
								if (bounds.bottom() > _selection.bottom()) {
									_selection.setBottom(bounds.bottom());
								}
							}
							break;
						}
					}
					if (f) {
						if (0 == _selected.contains(p)) {
							_selected.append(p);
						}
						p->drawShape(pwin, f);
					}
				}
			}
			//if (0 <= _preRect.x()) {
				pwin.setRasterOp(XorROP);
				pwin.setPen(QPen(white, 1));
				//pwin.drawRect(_preRect);
				drawRect(pwin, _preRect);
			//}
			pwin.flush();
			pwin.end();
		} else {
			if (0 >= _selection.width()) {
				return;
			}
			//I(ړ)
			QPainter pwin;
			pwin.begin(this);
			pwin.setRasterOp(XorROP);
			pwin.setPen(QPen(white, 1));
			//if (0 <= _last.x() - _tdx) {
				//pwin.drawRect(_preRect);
				drawRect(pwin, _preRect);
			//}
			//_last = evt->pos();
			_last = SnapPoint(evt->pos());
			//if (0 <= _last.x() - _tdx) {
				_preRect.setRect(_last.x() - _tdx, _last.y() - _tdy, _selection.width(), _selection.height());
				//pwin.drawRect(_preRect);
				drawRect(pwin, _preRect);
			//}
			pwin.flush();
			pwin.end();
		}
	} else {
		QPainter pwin;
		pwin.begin(this);
		pwin.setPen(_pen);

		pwin.drawLine(_last, evt->pos());
		pwin.flush();

		pwin.end();
		_last = evt->pos();
		_tracks.append(new QPoint(_last));
	}
}

void FNCanvas::mouseReleaseEvent(QMouseEvent* evt)
{
	_isDragging = false;
	if (_isWaiting) {
		_isWaiting = false;
		return;
	}
	if (MODE_ERASE == _drawMode) {
		if (_isSelected) {
			//_lastֈړ
			//_last = evt->pos();
			_last = SnapPoint(evt->pos());
			int dx = _last.x() - _tdx - _selection.x();
			int dy = _last.y() - _tdy - _selection.y();
			for (uint i = 0; i < _selected.count(); ++i) {
				FNPolygon* p = _selected.at(i);
				p->translate(dx, dy);
			}
			_selection.moveBy(dx, dy);
		}
		if (0 < _selection.width()) {
			_isSelected = true;
		}
		_last = QPoint(-1, -1);
		_tracks.clear();
		_isHeadingEnables = false;
		redraw();
	} else {
		if (1 < _tracks.count()) {
			_last = evt->pos();
			FNPolygon* p = NULL;
			if (MODE_FORMAT == _drawMode) {
				p = new FNPolygon(_pen);
				_tracks = AutoFormat(_tracks);
			} else if (MODE_CURVE == _drawMode) {
				QPoint sp = SnapPoint(*_tracks.at(0));
				QPoint ep = SnapPoint(*_tracks.at(_tracks.count()-1));
				_tracks = AutoCurve(_tracks);
				if (sp == ep) {
					p = new FNEllipse(_pen);
				} else if (2 < _tracks.count()) {
					p = new FNBezier(_pen);
				} else {
					p = new FNPolygon(_pen);
				}
			} else if (MODE_SMOOTH == _drawMode) {
				_tracks = Smoothing(_tracks);
				if (2 < _tracks.count()) {
					p = new FNBezier(_pen);
				} else {
					p = new FNPolygon(_pen);
				}
			} else {
				_tracks = Reduce(_tracks);
				p = new FNPolygon(_pen);
			}
			if (1 < _tracks.count()) {
				p->setPoints(_tracks);
				redobuf_flush();
				_draws.append(p);
			}
		} else if (MODE_TEXT == _drawMode) {
			if (NULL == _txtTmp) {
				textEdit(_last.x(), _last.y());
			} else {
				QRect r = _txtTmp->boundingRect();
				if (_selection == r) {
					textEdit(r.x(), r.y(), _txtTmp);
				} else {
					if (-1 != _selection.width()) {
						_txtTmp->translate(_last.x() - r.x(), _last.y() - r.y());
					}
				}
			}
			_txtTmp = NULL;
		}
		_tracks.clear();
		_isHeadingEnables = true;
		_timer->start(_scrollTiming, true);
	}
}

void FNCanvas::textEdit(int x, int y, FNText* obj)
{
	FNTextDialog dlg(fontname, this);
	dlg.showMaximized();
	QPen pen = _pen;
	if (NULL != obj) {
		for (uint i = 0; i < obj->lines.count(); ++i) {
			dlg.lines->append(obj->lines[i]);
		}
		pen = obj->pen();
	}
	dlg.setPen(pen);
	
	int mx = x;
	int my = y;
	if (dlg.exec()) {
		pen = dlg.pen();
		if (0 < dlg.lines->text().length()) {
			FNText* p = obj;
			if (NULL == obj) {
				p = new FNText(pen);
				_draws.append((FNPolygon*)p);
			}
			p->pen() = pen;
			p->lines.clear();
			FNPointList l;
			l.append(new QPoint(x, y));
			QFont font(fontname);
			font.setPointSize(FONTSIZE[pen.width()]);
			QFontMetrics fm(font);
			int h = fm.height();
			for (int i = 0; i < dlg.lines->numLines(); ++i) {
				p->lines.append(dlg.lines->textLine(i));
				int w = fm.width(dlg.lines->textLine(i)) + x;
				l.append(new QPoint(w, my));
				my += h;
				l.append(new QPoint(w, my));
				l.append(new QPoint(x, my));
				if (mx < w) {
					mx = w;
				}
			}
			p->setPoints(l);
			redobuf_flush();
			redraw();
		} else {
			if (NULL != obj) {
				_draws.remove(obj);
			}
		}
	}
}
void FNCanvas::paintEvent(QPaintEvent*)
{
	bitBlt(this, 0, 0, &_buffer);
}

void FNCanvas::resizeEvent(QResizeEvent* evt)
{
	QPixmap save(_buffer);
	_buffer.resize(evt->size());
	_buffer.fill(white);
	bitBlt(&_buffer, 0, 0, &save);
	redraw();
}

void FNCanvas::setOrigin(QPoint& o)
{
	this->setOrigin(o.x(), o.y());
}

QPoint FNCanvas::getTopLeft()
{
	if (0 == _draws.count() || !_isUseAllQuadrant) {
		return _origin;
	}

	int dx = ((FNPolygon*)_draws.at(0))->boundingRect().x();
	int dy = ((FNPolygon*)_draws.at(0))->boundingRect().y();
	for (uint i = 1; i < _draws.count(); ++i) {
		FNPolygon* p = _draws.at(i);
		if (dx > p->boundingRect().x()) {
			dx = p->boundingRect().x();
		}
		if (dy > p->boundingRect().y()) {
			dy = p->boundingRect().y();
		}
	}
	return QPoint(snap(dx), snap(dy));
}


void FNCanvas::rebuild()
{
	if (0 == _draws.count() || !_isUseAllQuadrant) {
		return;
	}

	QPoint d = getTopLeft();
	d.setX(d.x() - SNAP_SIZE);
	d.setY(d.y() - SNAP_SIZE);
	for (uint i = 0; i < _draws.count(); ++i) {
		FNPolygon* p = _draws.at(i);
		p->translate(-d.x(), -d.y());
	}

	_origin = QPoint(0, 0);
}

void FNCanvas::resetOrigin()
{
	int ox = 0;
	int oy = 0;
	_isHeadingEnables = false;
	_timer->stop();


	int dx = 0;
	int dy = 0;
	if (!_isUseAllQuadrant) {
		if (0 > ox) {
			ox = 0;
		}
		if (0 > oy) {
			oy = 0;
		}
		dx = _origin.x() - ox;
		dy = _origin.y() - oy;
	} else {
		dx = _origin.x() - ox;
		dy = _origin.y() - oy;
		if (0 > ox) {
			ox = 0;
		}
		if (0 > oy) {
			oy = 0;
		}
	}
	for (uint i = 0; i < _tracks.count(); ++i) {
		QPoint* p = _tracks.at(i);
		p->setX(p->x() + dx);
		p->setY(p->y() + dy);
	}

	for (uint i = 0; i < _draws.count(); ++i) {
		FNPolygon* p = _draws.at(i);
		p->translate(dx, dy);
	}
	_origin = QPoint(ox, oy);
}

void FNCanvas::setOrigin(int ox, int oy)
{
	ox = snap(ox);
	oy = snap(oy);
	_isHeadingEnables = false;
	_timer->stop();


	int dx = 0;
	int dy = 0;
	if (!_isUseAllQuadrant) {
		if (0 > ox) {
			ox = 0;
		}
		if (0 > oy) {
			oy = 0;
		}
		dx = _origin.x() - ox;
		dy = _origin.y() - oy;
	} else {
		dx = _origin.x() - ox;
		dy = _origin.y() - oy;
		if (0 > ox) {
			ox = 0;
		}
		if (0 > oy) {
			oy = 0;
		}
	}
	for (uint i = 0; i < _tracks.count(); ++i) {
		QPoint* p = _tracks.at(i);
		p->setX(p->x() + dx);
		p->setY(p->y() + dy);
	}

	for (uint i = 0; i < _draws.count(); ++i) {
		FNPolygon* p = _draws.at(i);
		p->translate(dx, dy);
	}
	if (-1 != _selection.width()) {
		_selection.moveBy(dx, dy);
	}
	_origin = QPoint(ox, oy);
	emit originChanged(ox, oy);
	redraw();
}

void FNCanvas::redraw()
{
	if (_isDrawing) {
		return;
	}
	if (_isDragging) {
		return;
	}
	if (!this->isVisible()) {
		return;
	}
	int h = height(); //(height() / 40) * 40;
	_isDrawing = true;
	_buffer.fill(white);
	QRect r = QRect(0, 0, width(), height());
	QPainter pbuf;
	pbuf.begin(&_buffer);
	pbuf.setFont(QFont(fontname));
	pbuf.setClipRect(0, 0, width(), height());
	/*
	char cvbuf[1024];
	sprintf(cvbuf, "(%d, %d), h:%d st:%d m:%d sn:%d", _origin.x(), _origin.y(), height(), height()/_margin, _margin, SNAP_SIZE);
	pbuf.setPen(QPen(QColor(0, 0, 0), 1));
	pbuf.drawText(0, 80, cvbuf);
	*/
	if (_viewMode) {
		float wx = 0;
		float wy = 0;
		for (uint i = 0; i < _draws.count() - _disp_offset; ++i) {
			FNPolygon* p = _draws.at(i);
			QRect r = p->boundingRect();
			if (wx < r.right()) {
				wx = r.right();
			} 
			if (wy < r.bottom()) {
				wy = r.bottom();
			}
		}
		wx += SNAP_SIZE;
		wy += SNAP_SIZE;
		wx = snap((int)wx);
		wy = snap((int)wy);
		wx = wx + _origin.x();
		wy = wy + _origin.y();
		_scale_x = (float)width() / wx;
		_scale_y = (float)height() / wy;
		if (1.0f < _scale_x) { 
			_scale_x = 1.0f;
		}
		if (1.0f < _scale_y) {
			_scale_y = 1.0f;
		}
		if (_scale_x > _scale_y) {
			_scale_x = _scale_y;
		} else if (_scale_x < _scale_y) {
			_scale_y = _scale_x;
		}
		for (uint i = 0; i < _draws.count() - _disp_offset; ++i) {
			FNPolygon* p = _draws.at(i);
			FNPolygon* t = NULL;
			if (p->type() == FN_BEZIER) {
				t = new FNBezier(*(FNBezier*)p);
			} else if (p->type() == FN_ELLIPSE) {
				t = new FNEllipse(*(FNEllipse*)p);
			} else if (p->type() == FN_TEXT) {
				t = new FNText(*(FNText*)p);
			} else {
				t = new FNPolygon(*p);
			}
			t->translate(-_origin.x(), -_origin.y());
			for (uint j = 0; j < t->points().count(); ++j) {
				QPoint& pts = t->points().at(j);
				int x = (int)(pts.x() * _scale_x);
				int y = (int)(pts.y() * _scale_y);
				pts.setX(x);
				pts.setY(y);
			}
			double pensize = t->pen().width();
			if (_scale_x > _scale_y) {
				pensize = pensize * _scale_y;
			} else {
				pensize = pensize * _scale_x;
			}
			if (0 >= pensize) {
				pensize = 1;
			}
			if (p->type() == FN_TEXT) {
				FNText* tp = (FNText*)t;
				QPoint& sp = t->points().at(0);

				//default font size checking...
				QFont f(fontname, FONTSIZE[p->pen().width()]);
				QFontMetrics fm(f);
				int h = fm.height();
				int wx = 0;
				int wy = 0;
				for (uint i = 0; i < tp->lines.count(); ++i) {
					int tw = fm.width(tp->lines[i]);
					if (tw > wx) {
						wx = tw;
					}
					wy += h;
				}

				//create default font image...
				QRect r = tp->boundingRect();
				QPixmap tmp(wx + 1, wy + 1);
				tmp.fill(Qt::white);
				QPainter pt;
				pt.begin(&tmp);
				pt.setFont(f);
				pt.setPen(p->pen());
				int y = h + 1;
				for (uint i = 0; i < tp->lines.count(); ++i) {
					pt.drawText(1, y, tp->lines[i]);
					y += h;
				}
				pt.flush();
				pt.end();

				//draw to font image
				tmp = tmp.convertToImage().smoothScale(r.width(), r.height());
				tmp.setMask(tmp.createHeuristicMask());
				pbuf.drawPixmap(sp.x(), sp.y(), tmp);
				pbuf.flush();
			} else {
				t->pen().setWidth(pensize);
				t->drawShape(pbuf);
			}
			delete t;
		}
	} else if (MODE_ERASE != _drawMode) {
		if (MODE_FORMAT == _drawMode || MODE_CURVE == _drawMode || MODE_TEXT == _drawMode) {
			QPen pen1(QColor(0, 240, 240), 1);
			QPen pen2(QColor(0, 0, 0), 1);
			pbuf.setPen(QPen(QColor(0, 240, 240), 1));
			pbuf.setPen(pen1);
			for (int x = 0; x < width() + SNAP_SIZE; x += SNAP_SIZE) {
				pbuf.drawLine(x - SNAP_SIZE / 2, 0, x - SNAP_SIZE / 2, h);
				for (int y = 0; y < h + SNAP_SIZE; y += SNAP_SIZE) {
					pbuf.drawLine(0, y - SNAP_SIZE / 2, width(), y - SNAP_SIZE / 2);
					pbuf.drawRect(x-1,y-1,2,2);
				}
			}
		} else {
			/*
			if (_showRuler) {
				pbuf.setPen(QPen(QColor(0, 200, 200), 1, DashDotDotLine));
				int step = h / _margin;
				for (int i = step; i < h; i += step) {
					pbuf.drawLine(0, i, width(), i);
				}
			}
			*/
		}
		if (_isShowGuide) {
			pbuf.setPen(QPen(cyan, 1, DashLine));
			if (AS_HORIZONTAL == _asMode || AS_BOTH == _asMode) {
				if (0 != _origin.x() || _isUseAllQuadrant) {
					pbuf.drawLine(width() / _margin, 0, width() / _margin, h);
				}
				pbuf.drawLine(width() * (_margin - 1) / _margin, 0, width() * (_margin - 1) / _margin, h);
			}

			if (AS_VERTICAL == _asMode || AS_BOTH == _asMode) {
				if (0 != _origin.y() || _isUseAllQuadrant) {
					pbuf.drawLine(0, h / _margin, width(), h / _margin);
				}
				pbuf.drawLine(0, h * (_margin - 1) / _margin, width(), h * (_margin - 1) / _margin);
			}
		}

		for (uint i = 0; i < _draws.count() - _disp_offset; ++i) {
			FNPolygon* p = _draws.at(i);
			if (r.intersects(p->boundingRect())) {
				p->drawShape(pbuf);
			}
		}
		if (!(MODE_FORMAT == _drawMode || MODE_CURVE == _drawMode || MODE_TEXT == _drawMode)) {
			if (_showRuler) {
				pbuf.setPen(QPen(QColor(200, 200, 200), 1, SolidLine));
				int step = snap(height() / _margin);
				for (int i = 0; i < height(); i += step) {
					pbuf.drawLine(0, i, width(),  i);
				}
			}
		}
	} else {
		for (uint i = 0; i < _draws.count() - _disp_offset; ++i) {
			FNPolygon* p = _draws.at(i);
			if (r.intersects(p->boundingRect())) {
				p->drawShape(pbuf);
			}
		}
		for (uint i = 0; i < _selected.count(); ++i) {
			_selected.at(i)->drawShape(pbuf, true);
		}
	}
	pbuf.end();
	_isDrawing = false;
	repaint();
}

void FNCanvas::changeColor(QRgb c)
{
	_pen.setColor(QColor(c));
	if (_isSelected) {
		for (uint i = 0; i < _selected.count(); ++i) {
			_selected.at(i)->pen().setColor(QColor(c));
		}
	}
}

void FNCanvas::selectionMoveTo(int dx, int dy)
{
	if (_isSelected) {
		for (uint i = 0; i < _selected.count(); ++i) {
			_selected.at(i)->translate(dx, dy);
		}
		_selection.moveBy(dx, dy);
	}
	redraw();
}

void FNCanvas::copy()
{
	if (MODE_ERASE != _drawMode || _viewMode) {
		return;
	}
	_clipboard.clear();
	for (uint i = 0; i < _selected.count(); ++i) {
		FNPolygon* p = _selected.at(i);
		if (FN_BEZIER == p->type()) {
			_clipboard.append(new FNBezier(*((FNBezier*)p)));
		} else if (FN_ELLIPSE == p->type()) {
			_clipboard.append(new FNEllipse(*((FNEllipse*)p)));
		} else if (FN_TEXT == p->type()) {
			_clipboard.append(new FNText(*((FNText*)p)));
		} else {
			_clipboard.append(new FNPolygon(*((FNPolygon*)p)));
		}
	}
}

void FNCanvas::paste()
{
	if (MODE_ERASE != _drawMode || _viewMode) {
		return;
	}
	_selected.clear();
	_selection = QRect(0, 0, -1, -1);
	for (uint i = 0; i < _clipboard.count(); ++i) {
		FNPolygon* p = _clipboard.at(i);
		FNPolygon* o = NULL;
		if (FN_BEZIER == p->type()) {
			o = new FNBezier(*((FNBezier*)p));
		} else if (FN_ELLIPSE == p->type()) {
			o = new FNEllipse(*((FNEllipse*)p));
		} else if (FN_TEXT == p->type()) {
			o = new FNText(*((FNText*)p));
		} else {
			o = new FNPolygon(*((FNPolygon*)p));
		}
		o->translate(10, 10);
		QRect bounds = o->boundingRect();
		if (-1 == _selection.width()) {
			_selection = bounds;
		} else {
			if (bounds.x() < _selection.x()) {
				_selection.setX(bounds.x());
			}
			if (bounds.y() < _selection.y()) {
				_selection.setY(bounds.y());
			}
			if (bounds.right() > _selection.right()) {
				_selection.setRight(bounds.right());
			}
			if (bounds.bottom() > _selection.bottom()) {
				_selection.setBottom(bounds.bottom());
			}
		}
		_draws.append(o);
		_selected.append(o);
	}
	_isSelected = true;
	redraw();
}

void FNCanvas::redo()
{
	if (MODE_ERASE != _drawMode) {
		if (0 < _disp_offset) {
			--_disp_offset;
		}
	}
	redraw();
}

void FNCanvas::clearList(FNPolygonList& list)
{
	list.setAutoDelete(true);
	list.clear();
	list.setAutoDelete(false);
}

void FNCanvas::resetSelection()
{
	_selection = QRect(0, 0, -1, -1);
	_selected.clear();
	_isSelected = false;
}

void FNCanvas::clear()
{
	resetSelection();
	_disp_offset = 0;
	clearList(_draws);
	_undobuf.clear();
	setOrigin(0, 0);
	redraw();
}

void FNCanvas::undo()
{
	if (MODE_ERASE != _drawMode) {
		++_disp_offset;
		if (_disp_offset > _draws.count()) {
			_disp_offset = _draws.count();
		}
	} else {
		_marks.clear();
		for (uint i = 0; i < _draws.count(); ++i) {
			FNPolygon* p = _draws.at(i);
			if (0 == _undobuf.contains(p)) {
				_marks.append(p);
			}
		}
		resetSelection();
		_draws = _undobuf;
		clearList(_marks);
	}
	redraw();
}

void FNCanvas::viewChanged(bool flg)
{
	_tracks.clear();
	_viewMode = flg;
	if (_viewMode) {
		if (_isUseAllQuadrant) {
			rebuild();
		}
		setOrigin(0, 0);
	}
	redraw();
}

void FNCanvas::redobuf_flush()
{
	for (uint i = 0; i < _disp_offset; ++i) {
		FNPolygon* p = _draws.last();
		_draws.remove(p);
		delete p;
	}
	_disp_offset = 0;
}

void FNCanvas::modeChanged(int mode)
{
	_tracks.clear();
	resetSelection();
	_drawMode = mode;
	redobuf_flush();
	if (MODE_ERASE == _drawMode) {
		_marks.clear();
		_undobuf = _draws;
	} else {
		if (_draws.count() != _undobuf.count()) {
			for (uint i = 0; i < _marks.count(); ++i) {
				FNPolygon* p = _marks.at(i);
				_draws.remove(p);
			}
			clearList(_marks);
		}
	}
	redraw();
}

QRect FNCanvas::getMatrix(const QRect& r) const
{
	int ox = _origin.x();
	int oy = _origin.y();
	const int wide = 100;

	int left = r.left() + ox;
	int top = r.top() + oy;
	int right = r.right() + ox;
	int bottom = r.bottom() + oy;
	
	left = (int)(left / wide) * wide;
	top = (int)(top / wide) * wide;
	right = (right % wide == 0 && left != right) ? right : (int)((right + wide) / wide) * wide;
	bottom = (bottom % wide == 0 && top != bottom) ? bottom : (int)((bottom + wide) / wide) * wide;
	
	return QRect(left - ox, top - oy, right - left, bottom - top);
}

void FNCanvas::CR() 
{
	if (MODE_ERASE == _drawMode) {
		return;
	}
	int h = height(); //(height() / 40) * 40;
	int step = snap(h) / _margin;
	if (_isHeadingEnables) {
		//lastAɌĒTB
		QRect r = getMatrix(_draws.last()->boundingRect());
		bool isSearching = true;
		r.moveBy(-100, 0);
		while (isSearching) {
			isSearching = false;
			for (uint i = 0; i < _draws.count(); ++i) {
				FNPolygon* p = _draws.at(i);
				const QRect& r2 = p->boundingRect();
				if (r.intersects(r2)) {
					if (r.left() + 100 > r2.left()) {
						r = getMatrix(r2);
						r.moveBy(-100, 0);
						isSearching = true;
						break;
					}
				}
			}
		}
		r.moveBy(100, 0);
		//lastʂ4/5ȉȂ΁AXN[AbvB
		//łȂ΁AwbfBÔ݁B
		if (_last.y() > h * 4 / 5) {
			setOrigin(_origin.x() + r.x(), _origin.y() +  step);
		} else {
			setOrigin(_origin.x() + r.x(), _origin.y());
		}
		_isHeadingEnables = false;
	} else {
		//last̎͂ɉꍇ́AcɃXN[B
		setOrigin(_origin.x(), _origin.y() +  step);
	}
}

void FNCanvas::erase()
{
	if (MODE_ERASE != _drawMode) {
		return;
	}
	FNPolygonList temp;
	int w = _eraser_s;
	if (PENWIDTH_MAX / 2 < _pen.width()) {
		w = _eraser_l;
	}
	for (uint i = 0; i < _selected.count(); ++i) {
		_draws.remove(_selected.at(i));
		_marks.append(_selected.at(i));
	}
	resetSelection();
	_tracks.clear();
	redraw();
}

void FNCanvas::setPensize(int sz)
{
	_pen.setWidth(sz);
	if (_isSelected) {
		for (uint i = 0; i < _selected.count(); ++i) {
			if (FN_TEXT != _selected.at(i)->type()) {
				_selected.at(i)->pen().setWidth(sz);
			}
		}
	}
}

bool FNCanvas::exportPNG(const QFileInfo& info, QPixmap& buf)
{
	if (0 == info.fileName().length()) {
		QMessageBox::warning(0,"FreeNoteQt", tr("file name is empty."));
		return false;
	}
	if (info.extension(false) != "png") {
		QMessageBox::warning(0,"FreeNoteQt", tr("extension '.png' expected."));
		return false;
	}

	bool ret = buf.save(info.absFilePath(), "PNG");
	if (ret) {
		FNMessageBox::information(0,"FreeNoteQt", tr("export PNG complete."));
	} else {
		QMessageBox::warning(0,"FreeNoteQt", tr("could not export file."));
	}
	return ret;
}

bool FNCanvas::save(const QFileInfo& info)
{
	if (0 == info.fileName().length()) {
		QMessageBox::warning(0,"FreeNoteQt", tr("file name is empty."));
		return false;
	}
	if (info.extension(false) != "free") {
		QMessageBox::warning(0,"FreeNoteQt", tr("extension '.free' expected."));
		return false;
	}
	FILE* fp = NULL;
	if (!(fp = fopen(info.absFilePath().utf8(), "wt"))) {
		QMessageBox::warning(0,"FreeNoteQt", tr("could not save file."));
		return false;
	}
	QPoint o = getTopLeft();
	rebuild();
	fputs("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n", fp);
	fputs("<freenote version=\"2.1\">\n", fp);
	char buf[1024];
	for (uint i = 0; i < _draws.count() - _disp_offset; ++i) {
		FNPolygon p(*_draws.at(i));
		p.translate(_origin.x(), _origin.y());
		if (p.type() == FN_BEZIER) {
			sprintf(buf, "\t<bz color=\"%x\" width=\"%d\">\n", (uint)p.pen().color().rgb(), p.pen().width());
		} else if (p.type() == FN_ELLIPSE) {
			sprintf(buf, "\t<el color=\"%x\" width=\"%d\">\n", (uint)p.pen().color().rgb(), p.pen().width());
		} else if (p.type() == FN_TEXT) {
			sprintf(buf, "\t<tx color=\"%x\" width=\"%d\">\n", (uint)p.pen().color().rgb(), p.pen().width());
		} else {
			sprintf(buf, "\t<po color=\"%x\" width=\"%d\">\n", (uint)p.pen().color().rgb(), p.pen().width());
		}
		fputs(buf, fp);
		QPointArray& points = p.points();
		for (uint j = 0; j < points.count(); ++j) {
			QPoint point = points.point(j);
			sprintf(buf, "\t\t<p x=\"%d\" y=\"%d\"/>\n", point.x(), point.y());
			fputs(buf, fp);
		}
		if (p.type() == FN_BEZIER) {
			fputs("\t</bz>\n", fp);
		} else if (p.type() == FN_ELLIPSE) {
			fputs("\t</el>\n", fp);
		} else if (p.type() == FN_TEXT) {
			FNText* tp = (FNText*)_draws.at(i);
			for (uint j = 0; j < tp->lines.count(); ++j) {
				QString s = "\t\t<t v=\"";
				s += tp->lines[j];
				s += "\"/>\n";
				fputs(s.utf8(), fp);
			}
			fputs("\t</tx>\n", fp);
		} else {
			fputs("\t</po>\n", fp);
		}
	}
	fputs("</freenote>\n", fp);
	fclose(fp);
	if (_isUseAllQuadrant) {
		setOrigin(-o.x(), -o.y());
	}
	FNMessageBox::information(0, "FreeNoteQt", tr("save complete."));
	return true;
}

bool FNCanvas::load(const QFileInfo& info)
{
	if (0 == info.fileName().length()) {
		QMessageBox::warning(0,"FreeNoteQt", tr("file name is empty."));
		return false;
	}
	if (!info.exists()) {
		QMessageBox::warning(0,"FreeNoteQt", tr("file not exists."));
		return false;
	}
	FILE* fp = NULL;
	if (!(fp = fopen(info.absFilePath().utf8(), "rt"))) {
		QMessageBox::warning(0,"FreeNoteQt", tr("could not open file."));
		return false;
	}
	clear();
	open(_draws, fp);
	fclose(fp);

	redraw();
	FNMessageBox::information(0,"FreeNoteQt", tr("load complete."));

	return true;
}

bool FNCanvas::import(const QFileInfo& info)
{
	if (0 == info.fileName().length()) {
		QMessageBox::warning(0,"FreeNoteQt", tr("file name is empty."));
		return false;
	}
	if (!info.exists()) {
		QMessageBox::warning(0,"FreeNoteQt", tr("file not exists."));
		return false;
	}
	FILE* fp = NULL;
	if (!(fp = fopen(info.absFilePath().utf8(), "rt"))) {
		QMessageBox::warning(0,"FreeNoteQt", tr("could not open file."));
		return false;
	}
	clearList(_clipboard);
	open(_clipboard, fp);
	fclose(fp);
	if (0 < _clipboard.count()) {
		int x = _clipboard.at(0)->boundingRect().left();
		int y = _clipboard.at(0)->boundingRect().top();
		for (uint i = 1; i < _clipboard.count(); ++i) {
			if (y > _clipboard.at(i)->boundingRect().top()) {
				y = _clipboard.at(i)->boundingRect().top();
			}
			if (x > _clipboard.at(i)->boundingRect().left()) {
				x = _clipboard.at(i)->boundingRect().left();
			}
		}
		for (uint i = 0; i < _clipboard.count(); ++i) {
			_clipboard.at(i)->translate(-x, -y);
		}
	}
	FNMessageBox::information(0,"FreeNoteQt", tr("import complete."));

	return true;
}

void FNCanvas::open(FNPolygonList& list, FILE* fp)
{
	QString line;
	FNPointList points;
	points.setAutoDelete(true);
	int c;
	int w;
	QPen pen(Qt::black, 1);
	FNPolygon* polygon;
	
	char rdbuf[1024];
	char buf[1024];
	QString type = "";
	QStringList lines;
	while (!feof(fp)) {
		fgets(rdbuf, sizeof(rdbuf), fp);
		line = rdbuf;
		if (-1 != line.find("<fnpolygon ") ||
			-1 != line.find("<po ") ||
			-1 != line.find("<bz ") ||
			-1 != line.find("<el ") ||
			-1 != line.find("<tx ")
		) {
			if (-1 != line.find("<el ")) {
				type = "Ellipse";
			} else if (-1 != line.find("<bz ")) {
				type = "Bezier";
			} else if (-1 != line.find("<tx ")) {
				type = "Text";
				lines.clear();
			} else {
				type = "Polygon";
			}
			points.clear();
			int st = line.find("color") + 7;
			int ed = line.find("\"", st);
			strcpy(buf, line.mid(st, ed - st));
			sscanf(buf, "%x", &c);
			st = line.find("width") + 7;
			ed = line.find("\"", st);
			strcpy(buf, line.mid(st, ed - st));
			sscanf(buf, "%d", &w);
		} else if (-1 != line.find("<point ") ||
			-1 != line.find("<p ")
			) {
			int st = line.find("x=") + 3;
			int ed = line.find("\"", st);
			strcpy(buf, line.mid(st, ed - st));
			int x;
			sscanf(buf, "%d", &x);

			st = line.find("y=") + 3;
			ed = line.find("\"", st);
			strcpy(buf, line.mid(st, ed - st));
			int y;
			sscanf(buf, "%d", &y);
			points.append(createPts(x, y)); //oO΍
		} else if (-1 != line.find("<t ")) {
			int st = line.find("v=") + 3;
			int ed = line.findRev("\"");
			strcpy(buf, line.mid(st, ed - st));
			QTextCodec *codec = QTextCodec::codecForName("utf8");
			lines.append(codec->toUnicode(buf));
		} else if (-1 != line.find("</fnpolygon") || 
			-1 != line.find("</bz") ||
			-1 != line.find("</el") ||
			-1 != line.find("</po") ||
			-1 != line.find("</tx")) {
			pen.setColor((QRgb)c);
			pen.setWidth(w);
			if (type == "Bezier") {
				list.append(polygon = createBezier(pen)); //oO΍
			} else if (type == "Ellipse") {
				list.append(polygon = createEllipse(pen)); //oO΍
			} else if (type == "Text") {
				list.append(polygon = createText(pen, lines));
			} else {
				list.append(polygon = createPolygon(pen)); //oO΍
			}
			polygon->setPoints(points);
			points.clear();
		}
	}

}

FNPolygon* FNCanvas::createPolygon(QPen& pen)
{
	return new FNPolygon(pen);
}

FNPolygon* FNCanvas::createBezier(QPen& pen)
{
	return new FNBezier(pen);
}


FNPolygon* FNCanvas::createEllipse(QPen& pen)
{
	return new FNEllipse(pen);
}

FNPolygon* FNCanvas::createText(QPen& pen, QStringList& lines)
{
	FNText* p = new FNText(pen);
	p->lines = lines;
	return p;
}

QPoint* FNCanvas::createPts(int x, int y) 
{
	return new QPoint(x, y);
}

void FNCanvas::setGuide(bool f)
{
	_isShowGuide = f;
	redraw();
}
