/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2004/10/17 FreeNote 1.10.0[X
2003/12/04 ver 1.5.3pre
EnewpageƂAÕtH_ێB

2003/09/15 ver 1.4.0
EftHg̃t@C莩B

2003/08/15 FreeNote 1.2.1J
Eۑ̃oOC
E_CAO̎
EPNGt@Cւ̏o

2003/08/15 FreeNote 1.2J
EIvVǉ
EXN[KCh
EFreet@C֘At
EACR̕ύX

2003/08/05 FreeNote 1.1.1preJ
ENɕԂێ
E`惂[hؑւɏS\
EۑԒZk
EView[h̋ύX
Ej[̌ڂύX
*/
#include <qdir.h>
#include <qdatetime.h>
#include "fnfiledialog.h"

FNFileDialog::FNFileDialog(QWidget* parent, const char* filter, const char* title, bool isOpenDialog)
: QDialog(parent, 0, true, 0), _info("")
{
	this->setCaption(title);
	_vbox = new QVBoxLayout(this);
	_hbox = new QHBox(this);
	_edtFName = new QLineEdit(_hbox);
	if (isOpenDialog) {
		_edtFName->hide();
	}
	_vbox->addWidget(_hbox);
	_vbox->addWidget(_selector = new SlFileSelector("~/", filter, this, "fileselector"));
	_vbox->activate();
	connect(_selector, SIGNAL(fileSelected(const QFileInfo&)), this, SLOT(fileSelected(const QFileInfo&)));
	connect(_selector, SIGNAL(dirOpened(const QDir&)), this, SLOT(dirOpened(const QDir&)));
}

FNFileDialog::~FNFileDialog()
{
	delete _edtFName;
	delete _hbox;
	delete _vbox;
	delete _selector;
}

void FNFileDialog::dirOpened(const QDir& dir)
{
	_edtFName->setEnabled(!_selector->isTopDir());
	_info.setFile(dir, "");
}

void FNFileDialog::fileSelected(const QFileInfo& file)
{
	if (_info.absFilePath() == file.absFilePath()) {
		accept();
	} else {
		_info = file;
		_edtFName->setText(_info.fileName());
	}
}

void FNFileDialog::setCurrentFile(const QFileInfo& info)
{
	_info = info;
	if (0 == _info.fileName().length()) {
		QDir dir = _info.dir();
		QDateTime dtime = QDateTime::currentDateTime();
		QDate dt = dtime.date();
		QTime tm = dtime.time();
		char buf[11];
		sprintf(buf, "%02d%02d%02d%02d%02d", dt.year() % 100, dt.month(), dt.day(), tm.hour(), tm.minute());
		if (_info.dir().exists()) {
			_selector->createFileList(dir);
			_selector->setSelected();
			if (NULL != _selector->selected()) {
				_info.setFile(_info.dir(), _selector->selected()->fileName());
			} else {
				_info.setFile(_info.dir(), buf);
			}
		} else {
			_info.setFile("~/" + QString(buf));
		}
		_selector->setCurrentFile(_info.absFilePath());
		_edtFName->setText(buf);
	} else {
		_selector->setCurrentFile(_info.absFilePath());
		_edtFName->setText(_info.fileName());
	}
}

const QFileInfo& FNFileDialog::currentFile()
{
	QDir dir = _selector->currentDir();
	_info.setFile(dir, _edtFName->text());
	return _info;
}

bool FNFileDialog::isTopDir() const
{
	return _selector->isTopDir();
}
