/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2004/10/17 FreeNote 1.10.0[X
2004/02/12 ver 1.7.1pre
EtHgdl̕ύX
EeLXg̍
EeLXg{bNX̑@\
*/
#include "fntextdialog.h"
#include <stdio.h>
#include <qcombobox.h>
#include <qfontdatabase.h>
#include <qcolor.h>
#include <qtoolbutton.h>
#include <qpalette.h>
#include <qmultilineedit.h>

FNTextDialog::FNTextDialog(const QString& fontname, QWidget* parent = 0, const char* name = 0)
	:FNTextDialogBase(parent, name, true, 0), _pen(1)
{
	static QFontDatabase fbase;
	QValueList<int> sizes = fbase.pointSizes(fontname);
	_colorSelector = new SlColorSelectorPopup(false, this);
	_colorSelector->setCurrentColor((QRgb)0); 
	connect(_colorSelector, SIGNAL(selected(QRgb)), this, SLOT(changeColor(QRgb)));
	char buf[10];
	for (uint i = 0; i < sizes.count(); ++i) {
		sprintf(buf, "%d", sizes[i]);
		cboFontSize->insertItem(buf);
	}
	lines->setFont(QFont(fontname, 20));
}


FNTextDialog::~FNTextDialog()
{
	delete _colorSelector;
}

void FNTextDialog::changeColor(QRgb c)
{
	fraColor->setBackgroundColor(QColor(c));
	_pen.setColor(QColor(c));
}

void FNTextDialog::choose(int v)
{
	_pen.setWidth(v);
}

void FNTextDialog::btnColor_Clicked()
{
	_colorSelector->exec(btnColor->mapToGlobal(btnColor->rect().bottomLeft()));
}

void FNTextDialog::setPen(const QPen& pen)
{
	_pen = pen;
	if (cboFontSize->count() <= (int)pen.width()) {
		_pen.setWidth(cboFontSize->count()-1);
	}
	cboFontSize->setCurrentItem(_pen.width());
	fraColor->setBackgroundColor(_pen.color());
}

const QPen& FNTextDialog::pen() const
{
	return _pen;
}
