/*  FreeNote for Sharp SLA300, B500, C7x0 Linux PDA
	Copyright (C) 2003, 2004 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2004/06/30 ver 1.9.2pre
EIvVʂ𕪗

2004/05/23 ver 1.9.1Apre
EΉ

2004/02/26 ver 1.9.0pre
EC|[g@\
 
2004/02/16 ver 1.7.3pre
EҏW@\

2004/02/14 ver 1.7.2pre
E@\ǉ

2003/12/17 FreeNote 1.5.5pre
EQuit

2003/11/12 FreeNote 1.5.1pre
EMaximized{^ǉ

2003/08/20-23 FreeNote 1.3.0pre
ECR{^ǉ
EXN[[h̕ۑ
EKChԂ̕ۑ

2003/08/15 FreeNote 1.2.1J
Eۑ̃oOC
E_CAO̎
EPNGt@Cւ̏o

2003/08/15 FreeNote 1.2J
EIvVǉ
EXN[KCh
EFreet@C֘At
EACR̕ύX

2003/08/05 FreeNote 1.1.1preJ
ENɕԂێ
E`惂[hؑւɏS\
EۑԒZk
EView[h̋ύX
Ej[̌ڂύX
*/
#include <qlayout.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qgroupbox.h>
#include <qtoolbutton.h>
#include <qpixmap.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include "fnoptiondialog.h"
#include "fniconset.h"
FNOptionDialog::FNOptionDialog(QWidget* parent,  const FNOptionData& options) 
	: FNOptionDialogBase(parent, 0, true, 0), _options(options)
{
	btnFind->setOn(_options.isFindOn);
	btnFind->setPixmap(QPixmap((const char**)find_xpm));
	btnMaximized->setOn(_options.isMaximizedOn);
	btnMaximized->setPixmap(QPixmap((const char**)maximized_xpm));
	btnCopy->setOn(_options.isCopyOn);
	btnCopy->setPixmap(QPixmap((const char**)copy_xpm));
	btnPaste->setOn(_options.isPasteOn);
	btnPaste->setPixmap(QPixmap((const char**)paste_xpm));
	btnImport->setOn(_options.isImportOn);
	btnImport->setPixmap(QPixmap((const char**)import_xpm));
	btnUndo->setOn(_options.isUndoOn);
	btnUndo->setPixmap(QPixmap((const char**)undo_xpm));
	btnRedo->setOn(_options.isRedoOn);
	btnRedo->setPixmap(QPixmap((const char**)redo_xpm));
	btnColor->setOn(_options.isColorOn);
	btnColor->setPixmap(QPixmap((const char**)color_xpm));
	btnZoom->setOn(_options.isZoomOn);
	btnZoom->setPixmap(QPixmap((const char**)zoom_xpm));
	btnRet->setOn(_options.isCROn);
	btnRet->setPixmap(QPixmap((const char**)ret_xpm));
	btnGuide->setOn(_options.isGuideOn);
	btnGuide->setPixmap(QPixmap((const char**)guide_xpm));
	btnNew->setOn(_options.isNewOn);
	btnNew->setPixmap(QPixmap((const char**)new_xpm));
	btnClear->setOn(_options.isClearOn);
	btnClear->setPixmap(QPixmap((const char**)clear_xpm));
	btnLoad->setOn(_options.isOpenOn);
	btnLoad->setPixmap(QPixmap((const char**)open_xpm));
	btnSave->setOn(_options.isSaveOn);
	btnSave->setPixmap(QPixmap((const char**)save_xpm));
	btnExportPNG->setOn(_options.isExportPNGOn);
	btnExportPNG->setPixmap(QPixmap((const char**)png_xpm));
	//btnOption->setOn(_options.isOptionOn);
	//btnOption->setPixmap(QPixmap((const char**)setting_xpm));
	spbASTiming->setValue(_options.timing);
	spbASVSteps->setValue(_options.v_step);
	spbASHSteps->setValue(_options.h_step);
	scbASMargin->setValue(_options.margin);
	spbAFPhase1Angle->setValue(_options.phase1);
	spbAFPhase2Angle->setValue(_options.phase2);
	spbAFGridSize->setValue(_options.grid_size);
	spbERLargeSize->setValue(_options.eraser_l);
	spbERSmallSize->setValue(_options.eraser_s);
	ckbQuitQuickly->setChecked(_options.isQuitQuickly);
	txtToolName1->setText(_options.toolNames[0]);
	txtToolScript1->setText(_options.toolScripts[0]);
	txtToolName2->setText(_options.toolNames[1]);
	txtToolScript2->setText(_options.toolScripts[1]);
	txtToolName3->setText(_options.toolNames[2]);
	txtToolScript3->setText(_options.toolScripts[2]);
	txtToolName4->setText(_options.toolNames[3]);
	txtToolScript4->setText(_options.toolScripts[3]);
	txtToolName5->setText(_options.toolNames[4]);
	txtToolScript5->setText(_options.toolScripts[4]);
	txtToolName6->setText(_options.toolNames[5]);
	txtToolScript6->setText(_options.toolScripts[5]);
	txtToolName7->setText(_options.toolNames[6]);
	txtToolScript7->setText(_options.toolScripts[6]);
	txtToolName8->setText(_options.toolNames[7]);
	txtToolScript8->setText(_options.toolScripts[7]);
	txtWkDir->setText(_options.wkdir);
}

const FNOptionData& FNOptionDialog::options() const
{
	(QString&)_options.toolNames[0] = txtToolName1->text();
	(QString&)_options.toolScripts[0] = txtToolScript1->text();
	(QString&)_options.toolNames[1] = txtToolName2->text();
	(QString&)_options.toolScripts[1] = txtToolScript2->text();
	(QString&)_options.toolNames[2] = txtToolName3->text();
	(QString&)_options.toolScripts[2] = txtToolScript3->text();
	(QString&)_options.toolNames[3] = txtToolName4->text();
	(QString&)_options.toolScripts[3] = txtToolScript4->text();
	(QString&)_options.toolNames[4] = txtToolName5->text();
	(QString&)_options.toolScripts[4] = txtToolScript5->text();
	(QString&)_options.toolNames[5] = txtToolName6->text();
	(QString&)_options.toolScripts[5] = txtToolScript6->text();
	(QString&)_options.toolNames[6] = txtToolName7->text();
	(QString&)_options.toolScripts[6] = txtToolScript7->text();
	(QString&)_options.toolNames[7] = txtToolName8->text();
	(QString&)_options.toolScripts[7] = txtToolScript8->text();
	(QString&)_options.wkdir = txtWkDir->text();

	return _options;
}

void FNOptionDialog::phase1Changed(int v)
{
	_options.phase1 = v;
}

void FNOptionDialog::phase2Changed(int v)
{
	_options.phase2 = v;
}

void FNOptionDialog::gridSizeChanged(int v)
{
	_options.grid_size = v;
}

void FNOptionDialog::timingChanged(int v) //timing
{
	_options.timing = v;
}

void FNOptionDialog::v_stepChanged(int v) //v_step
{
	_options.v_step = v;
}

void FNOptionDialog::h_stepChanged(int v) //h_step
{
	_options.h_step = v;
}

void FNOptionDialog::marginChanged(int v) //margin
{
	_options.margin = v;
}

void FNOptionDialog::eraserSChanged(int v) //eraser_s
{
	_options.eraser_s = v;
}

void FNOptionDialog::eraserLChanged(int v) //eraser_l
{
	_options.eraser_l = v;
}

void FNOptionDialog::maximizedIconToggled(bool flg) //maximized
{
	_options.isMaximizedOn = flg;
}

void FNOptionDialog::findIconToggled(bool flg) //palette
{
	_options.isFindOn = flg;
}

void FNOptionDialog::paletteIconToggled(bool flg) //palette
{
	_options.isPaletteOn = flg;
}

void FNOptionDialog::copyIconToggled(bool flg) //copy
{
	_options.isCopyOn = flg;
}

void FNOptionDialog::pasteIconToggled(bool flg) //paste
{
	_options.isPasteOn = flg;
}

void FNOptionDialog::importIconToggled(bool flg) //import
{
	_options.isImportOn = flg;
}

void FNOptionDialog::undoIconToggled(bool flg) //undo
{
	_options.isUndoOn = flg;
}

void FNOptionDialog::redoIconToggled(bool flg) //undo
{
	_options.isRedoOn = flg;
}

void FNOptionDialog::boldIconToggled(bool flg)	//bold
{
	_options.isBoldOn = flg;
}

void FNOptionDialog::colorIconToggled(bool flg) //color
{
	_options.isColorOn = flg;
}

void FNOptionDialog::zoomIconToggled(bool flg) //zoom
{
	_options.isZoomOn = flg;
}

void FNOptionDialog::CRIconToggled(bool flg) //CR
{
	_options.isCROn = flg;
}

void FNOptionDialog::guideIconToggled(bool flg) //guide
{
	_options.isGuideOn = flg;
}
void FNOptionDialog::newIconToggled(bool flg) //new
{
	_options.isNewOn = flg;
}

void FNOptionDialog::clearIconToggled(bool flg) //clear
{
	_options.isClearOn = flg;
}

void FNOptionDialog::loadIconToggled(bool flg) //load
{
	_options.isOpenOn = flg;
}

void FNOptionDialog::saveIconToggled(bool flg) //save
{
	_options.isSaveOn = flg;
}

void FNOptionDialog::exportIconToggled(bool flg) //export
{
	_options.isExportOn = flg;
}

void FNOptionDialog::exportPNGIconToggled(bool flg) //exportPNG
{
	_options.isExportPNGOn = flg;
}

void FNOptionDialog::optionIconToggled(bool flg) //option
{
	_options.isOptionOn = flg;
}

void FNOptionDialog::quitQuicklyToggled(bool flg) //option
{
	_options.isQuitQuickly = flg;
}

FNOptionDialog::~FNOptionDialog()
{
}
